%{
#include "tcompil.h"
%}

%%

[ \t\n]+ ;

"/*"    {
    /*
     * Pour sauter les commentaires C.
     * D'aprs la documentation de flex.
     */
            int c;

	    while (1) {
                while ( (c = input()) != '*' && c != EOF )
                    ;    /* eat up text of comment */

                if ( c == '*' ) {
                    while ( (c = input()) == '*' )
                        ;
                    if ( c == '/' )
                        break;    /* found the end */
		}

                if ( c == EOF ) {
		    fprintf(stderr,"EOF in comment !\n");
		    return 0;
		}
	    }
	}

"main" { return MAIN; }
"return" { return RETURN; }
"void" { return VOID; }
"var" { return VAR; }
"const" { return CONST; }
"int" { return ENTIER; }

"read" { return READ; }
"write" { return PRINT; }

"if" { return IF; }
"else" { return ELSE; }
"while" { return WHILE; }

"try" { return TRY; }
"catch" { return CATCH; }

"OutOfBounds" { yylval.which_exception = OOB; return EXCEPTION; }
"IllegalSize" { yylval.which_exception = IS; return EXCEPTION; }
"DivisionByZero" { yylval.which_exception = DBZ; return EXCEPTION; }

"==" { yylval.which_comp = EGALITE; return COMP; }
"!=" { yylval.which_comp = DIFF; return COMP; }
"<" { yylval.which_comp = PPQ; return COMP; }
">" { yylval.which_comp = PGQ; return COMP; }
"<=" { yylval.which_comp = PPQE; return COMP; }
">=" { yylval.which_comp = PGQE; return COMP; }

"=" { return EGAL; }
";" { return PV; }
"," { return VRG; }
"(" { return LPAR; }
")" { return RPAR; }
"{" { return LACC; }
"}" { return RACC; }
"[" { return LSQB; }
"]" { return RSQB; }

"*" { yylval.which_op = MULT; return MULTDIV; }
"/" { yylval.which_op = DIV; return MULTDIV; }
"%" { yylval.which_op = MOD; return MULTDIV; }

"+" { yylval.which_op = ADD; return ADDSUB; }
"-" { yylval.which_op = SUB; return ADDSUB; }

[0-9]+ { sscanf(yytext, "%d", &yylval.entier); return NUM; }
[_a-zA-Z][_a-zA-Z0-9]* { 
    strncpy(yylval.chaine, yytext, 20); 
    if ( strlen(yytext) > 20 )
	printf("%s tronqu en %s\n",yytext,yylval.chaine);
    return IDENT; 
}

. return yytext[0];

%%
