#include "tablesymb.h"

int initSymbole(table * t)
{
    table tmp = malloc(sizeof(symbole *));
    if ( tmp == NULL )
	return 0;
    *tmp = NULL;
    *t = tmp;
    return 1;
}

int findSymbole_(const table t, const char * name, symbole ** s)
{
    if ( t == NULL )
	return 0;

    symbole * tmp = *t;

    while ( tmp != NULL ) {
	if ( strcmp(name, tmp->name) == 0 ) {
	    *s = tmp;
	    return 1;
	}
	tmp = tmp->next;
    }

    return 0;
}

int findSymbole(const table t, const char * name, symbole * s)
{
    if ( t == NULL )
	return 0;

    symbole * tmp = *t;

    while ( tmp != NULL ) {
	if ( strcmp(name, tmp->name) == 0 ) {
	    *s = *tmp;
	    return 1;
	}
	tmp = tmp->next;
    }

    return 0;
}

int addSymbole(const table t,
	const char * name, const int add, const int sign, const int size)
{
    symbole * tmp = malloc(sizeof(symbole));
    if ( tmp == NULL )
	return 0;

    if ( findSymbole(t, name, tmp) ) {
	free(tmp);
	return 0;
    }

    tmp->address = add;
    tmp->signature = sign;
    tmp->size = size;
    tmp->name = malloc(strlen(name)+1);
    if ( tmp->name == NULL ) {
	free(tmp);
	return 0;
    }
    strcpy(tmp->name, name);
    tmp->next = *t;
    *t = tmp;

    return 1;
}

void afficheSymbole(const table t)
{
    if ( t == NULL )
	return;
    symbole * tmp = *t;
    
    while ( tmp != NULL ) {
	fprintf(stderr,"[%-5d] %-20s : %-4d (size : %d)\n",
		tmp->address,tmp->name,	tmp->signature, tmp->size);
	tmp = tmp->next;
    }
}

void freeSymbole(table * t)
{
    if ( *t == NULL )
	return;

    table r = *t;
    symbole * tmp = **t;

    while ( tmp != NULL ) {
	free(tmp->name);
	*r = tmp->next;
	free(tmp);
	tmp = *r;
    }

    free(r);
}
