%{
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "tablesymb.h"
#include "yyutils.h"

int yylex();
FILE * tmpout = NULL;
FILE * yyin;

// constantes locales ( idem en dessous, signature = valeur )
table localconst = NULL; 
// (bidouille) la signature est la valeur de la constante
table constante = NULL; 
// variables globales et fonctions
table varfonc = NULL;
// variables locales (arguments compris !)
table locale = NULL; 
// Nombre de variables globales ou dans la fonction en cours de compilation
int nb_var = 0; 
// adresse de dbut des variables du main
int main_var_start;
// Boolen pour savoir si l'on est en train de compiler les arguments d'une 
// fonction ou non
int args = 0;
// Fonction en cours de compilation
symbole * currfonction = NULL;
// Place mmoire des arguments lors d'un appel de fonction
int arg_size;

%}

%union {
    enum { OOB, IS, DBZ } which_exception;
    enum { MULT, DIV, MOD, ADD, SUB } which_op;
    enum { EGALITE, DIFF, PPQ, PGQ, PPQE, PGQE } which_comp;
    int entier;
    char chaine[21];
}

%token IF ELSE WHILE PRINT READ MAIN VOID RETURN VAR CONST TRY CATCH EGAL PV VRG LPAR RPAR LACC RACC LSQB RSQB ENTIER
%token<which_op> ADDSUB MULTDIV
%token<which_comp> COMP
%token<which_exception> EXCEPTION
%token<entier> NUM
%token<chaine> IDENT
%token POUBELLE

%type<entier> FixJumpF FixJump FixLabel Instr NombreSigne Parametres ListVar Assignable Exp Type Arguments ListExp

%nonassoc POUBELLE
%nonassoc ELSE
%nonassoc CATCH
%nonassoc COMP
%left ADDSUB
%left MULTDIV

%%

Prog: DeclConst DeclVar { main_var_start = nb_var; nb_var = 0; } FixJump DeclFonct { label($4); currfonction = NULL} DeclMain
    ;

DeclConst: DeclConst CONST ListConst PV
    |
    ;

ListConst: ListConst VRG IDENT EGAL NombreSigne
	{
	    if ( ! addSymbole((localconst)?localconst:constante, $3, -1, $5, 0) )
		error("constante existante : ",$3);
	}
    | IDENT EGAL NombreSigne
	{
	    if ( ! addSymbole((localconst)?localconst:constante, $1, -1, $3, 0) )
		error("constante existante : ",$1);
	}
    ;

NombreSigne: NUM
	{
	    $$ = $1;
	}
    | ADDSUB NUM
	{
	    $$ = - $1;
	}
    ;

DeclVar: DeclVar VAR ListVar PV
    | 
    ;

ListVar: ListVar VRG Variable
	{
	    $$ = $1 + 1;
	}
    | Variable
	{
	    $$ = 1;
	}
    ;

Variable: IDENT LSQB NUM RSQB
	{
	    symbole s;
	    if ( findSymbole(localconst, $1, &s) )
		error("nom du tableau occup par un nom de variable : ",$1);
	    if ( findSymbole(constante, $1, &s) )
		error("nom du tableau occup par un nom de variable : ",$1);
	    if ( addSymbole((locale!=NULL)?locale:varfonc, $1,
		    (locale!=NULL)?(args)?((-((currfonction->size)?3:4)+(nb_var++))):nb_var++:(nb_var++), -1,$3) != 1 )
		error("tableau existant : ",$1);
	    if ( $3 < 0 )
		error("initialisation de tableau avec une taille ngative : ",$1);
	    if ( ! args )
		instarg("ALLOC", $3);
	}
    | IDENT LSQB IDENT RSQB
	{
	    // Tableau dont la taille est dans une constante
	    symbole s;
	    if ( findSymbole(localconst, $1, &s) )
		error("nom du tableau occup par un nom de variable : ",$1);
	    if ( findSymbole(constante, $1, &s) )
		error("nom du tableau occup par un nom de variable : ",$1);
	    if ( addSymbole((locale!=NULL)?locale:varfonc, $1, 
		    (locale!=NULL)?(args)?((-(currfonction->size)?3:4+(nb_var++))):nb_var++:(nb_var++), -1, s.signature) != 1 )
		error("tableau existant : ",$1);
	    if ( ! findSymbole(constante, $3, &s)
		    && ! findSymbole(localconst, $3, &s) ) {
		fprintf(stderr,"Impossible de trouver : %s\n",$3);
		error("constante introuvable, impossible d'initialiser le tableau : ",$1);
	    }
	    if ( s.signature < 0 )
		error("initialisation de tableau avec une taille ngative : ",$1);
	    if ( ! args )
		instarg("ALLOC", s.signature);
	}
    | IDENT
	{
	    symbole s;
	    if ( findSymbole(localconst, $1, &s) )
		error("symbole existante en temps que constante : ",$1);
	    if ( findSymbole(constante, $1, &s) )
		error("symbole existante en temps que constante : ",$1);
	    if ( addSymbole((locale!=NULL)?locale:varfonc, $1, 
		    (locale!=NULL)?(args)?(-((currfonction->size)?3:4)+(nb_var++)):nb_var++:(nb_var++), -1, 1) != 1 )
		error("variable existante : ",$1);
	    if ( ! args ) 
		instarg("ALLOC", 1);
	}
    ;

Assignable: IDENT LSQB Exp RSQB
	{
	    // XXX buggu ?
	    symbole s ;
	    if ( findSymbole(varfonc, $1, &s) )
		$$ = s.address;
	    else if ( findSymbole(locale, $1,& s) )
		$$ = s.address;
	    else if ( findSymbole(localconst, $1, &s) )
		error("impossible de modifier une constante : ",$1);
	    else if ( findSymbole(constante, $1, &s) )
		error("impossible de modifier une constante : ",$1);
	    else
		error("tableau introuvable : ",$1);
	    instarg("SET", s.address);
	    inst("SWAP");
	    inst("POP"); // Choppe Exp
	    inst("ADD");
	    inst("PUSH");
	}
    | IDENT
	{
	    symbole s ;
	    if ( findSymbole(varfonc, $1, &s) )
		$$ = s.address;
	    else if ( findSymbole(locale, $1,& s) )
		$$ = s.address;
	    else if ( findSymbole(localconst, $1, &s) )
		error("impossible de modifier une constante : ",$1);
	    else if ( findSymbole(constante, $1, &s) )
		error("impossible de modifier une constante : ",$1);
	    else
		error("variable introuvable : ",$1);
	    instarg("SET", s.address);
	    inst("PUSH");
	}
    ;

DeclMain: EnTeteMain { nb_var = main_var_start; initSymbole(&locale); initSymbole(&localconst); } Corps
    ;

EnTeteMain: MAIN LPAR RPAR
	{
	    comment("--- main ---");
	}
    ;

DeclFonct: DeclFonct DeclUneFonct
    |
    ;

DeclUneFonct: EnTeteFonct Corps 
	{
	    nb_var = 0;
	    freeSymbole(&locale);
	    freeSymbole(&localconst);
	    locale = NULL;
	    localconst = NULL;
	}
    ;

EnTeteFonct: { comment("--- new function ---"); } 
    Type IDENT LPAR 
	{ 
	    initSymbole(&locale); 
	    initSymbole(&localconst);
	    args = 1; 
	    symbole s;
	    if ( findSymbole(localconst, $3, &s) )
		error("symbole existant : ",$3);
	    if ( findSymbole(constante, $3, &s) )
		error("symbole existant : ",$3);
	    if ( ! addSymbole(varfonc, $3, line_counter, 0, $2) )
		error("fonction existante : ",$3);
	    findSymbole_(varfonc, $3, &currfonction);
	} 
    Parametres
	{ 
	    args = 0;
	    currfonction->signature = $6;
	    // Applique un dcalage pour les adresses des variables locales 
	    symbole * s = *locale;
	    while ( s != NULL ) {
		s->address -= currfonction->signature + s->size -1;
		s = s->next;
	    }
	} 
    RPAR
    ;

Type: ENTIER
	{
	    $$ = 1;
	}
    | VOID
	{
	    $$ = 0;
	}
    ;

Parametres: VOID
	{
	    $$ = 0;
	}
    | ListVar
	{
	    $$ = $1;
	}
    ;

Corps: LACC DeclConst DeclVar SuiteInstr RACC
    ;

SuiteInstr: SuiteInstr Instr
    |
    ;

InstrComp: LACC SuiteInstr RACC
    ;

Instr: Assignable EGAL Exp PV
	{
	    comment("--- affectation ---");
	    inst("POP"); // Choppe la valeur de Exp
	    inst("SWAP");
	    inst("POP"); // Choppe la valeur de Assignable
	    inst("SWAP");
	    if ( locale )
		inst("SAVER");
	    else
		inst("SAVE");
	}
    | IF LPAR Exp RPAR FixJumpF Instr %prec POUBELLE
	{
	    label($5);
	}
    | IF LPAR Exp RPAR FixJumpF Instr ELSE FixJump
	{
	    label($5);
	}
    Instr
	{
	    label($8);
	}
    | FixLabel WHILE LPAR Exp RPAR FixJumpF Instr
	{
	    jump("JUMP",$1);
	    label($6);
	}
    | RETURN Exp PV
	{
	    if ( currfonction->size == 0 )
		error("cette fonction ne retourne rien ! : ", currfonction->name);
	    comment("--- return value ---");
	    inst("POP");
	    inst("SWAP");
	    instarg("SET", -3);
	    inst("SWAP");
	    inst("SAVER");
	    inst("RETURN");
	}
    | RETURN PV
	{
	    if ( currfonction->size == 1 )
		error("cette fonction doit retourner quelque chose : ", currfonction->name);
	    comment("--- return ---");
	    inst("RETURN");
	}
    | IDENT LPAR { arg_size = 0; } Arguments RPAR PV
	{
	    arg_size = $4;
	    comment("--- function call ---");
	    symbole s;
	    if ( ! findSymbole(varfonc, $1, &s) )
		error("fonction introuvable : ",$1);
	    instarg("CALL", s.address);
	    if ( s.size ) // Sauvegarde la valeur de retour
		inst("POP");
	    instarg("FREE", arg_size); // Free les arguments
	    if ( s.size ) // Restaure la valeur de retour
		inst("PUSH");
	}
    | READ LPAR Assignable RPAR PV
	{
	    comment("--- read ---");
	    inst("POP"); // Choppe la valeur de Assignable
	    inst("SWAP");
	    inst("READ");
	    if ( locale )
		inst("SAVER");
	    else
		inst("SAVE");
	}
    | PRINT LPAR Exp RPAR PV 
	{
	    comment("--- write ---");
	    inst("POP");
	    inst("WRITE");
	}
    | PV
	{
	    // Rien  faire
	}
    | InstrComp
	{
	    // Rien  faire
	}
    | TRY Instr ListCatch %prec POUBELLE
	{
	    // Tout  faire ^_^'
	}
    ;

ListCatch: Catch
    | ListCatch Catch
    ;

Catch: CATCH LPAR EXCEPTION RPAR Instr
    ;

Arguments: ListExp { $$ = $1; }
    | { $$ = 0; }
    ;

ListExp: ListExp VRG Exp { $$ = $1 + 1; }
    | Exp { $$ = $1; }
    ;

Exp: Exp ADDSUB Exp
	{
	    comment("--- add/sub ---");
	    inst("POP");
	    inst("SWAP");
	    inst("POP");
	    switch($2) {
		case ADD: // +
		    inst("ADD");
		    break;
		case SUB: // -
		    inst("SUB");
		    break;
		case MULT:
		case MOD:
		case DIV:
		    break;
	    }
	    inst("PUSH");
	    $$ = 1;
	}
    | Exp MULTDIV Exp
	{
	    comment("--- mult/div/mod ---");
	    inst("POP");
	    inst("SWAP");
	    inst("POP");
	    switch($2) {
		case ADD:
		case SUB:
		    break;
		case MULT: // *
		    inst("MULT");
		    break;
		case MOD: // %
		    inst("MOD");
		    break;
		case DIV: // /
		    inst("DIV");
		    break;
	    }
	    inst("PUSH");
	    $$ = 1;
	}
    | Exp COMP Exp
	{
	    comment("--- comp ---");
	    inst("POP");
	    inst("SWAP");
	    inst("POP");
	    switch($2) {
		case EGALITE: // ==
		    inst("EQUAL");
		    break;
		case DIFF: // !=
		    inst("NOTEQ");
		    break;
		case PPQ: // <
		    inst("LOW");
		    break;
		case PGQ: // >
		    inst("GREAT");
		    break;
		case PPQE: // <=
		    inst("LEQ");
		    break;
		case PGQE: // >=
		    inst("GEQ");
		    break;
	    }
	    inst("PUSH");
	    $$ = 1;
	}
    | ADDSUB Exp
	{
	    comment("--- neg ---");
	    inst("POP");
	    inst("NEG");
	    inst("PUSH");
	    $$ = 1;
	}
    | LPAR Exp RPAR
	{
	    // Rien  faire
	}
    | IDENT
	{
	    comment("--- var ---");
	    symbole s;
	    if ( findSymbole(locale, $1, &s) ) {
		instarg("SET", s.address);
		inst("LOADR");
	    } else if ( findSymbole(varfonc, $1, &s) ) {
		instarg("SET", s.address);
		inst("LOAD");
	    } else if ( findSymbole(localconst, $1, &s) ) {
		instarg("SET", s.signature);
	    } else if ( findSymbole(constante, $1, &s) ) {
		instarg("SET", s.signature);
	    } else {
		error("variable introuvable : ",$1);
	    }
	    inst("PUSH");
	    $$ = (s.size)?s.size:1;
	}
    | IDENT LSQB Exp RSQB
	{
	    comment("--- array ---");
	    inst("POP"); // Choppe Exp
	    inst("SWAP");
	    symbole s;
	    if ( findSymbole(localconst, $1, &s) )
		error("symbole est une constante : ",$1);
	    if ( findSymbole(constante, $1, &s) )
		error("symbole est une constante : ",$1);
	    if ( ! findSymbole((locale)?locale:varfonc, $1, &s) )
		error("symbole introuvable : ",$1);
	    if ( s.signature != -1 )
		error("symbole est une fonction : ",$1);
	    instarg("SET", s.address);
	    inst("ADD");
	    if ( locale )
		inst("LOADR");
	    else
		inst("LOAD");
	    inst("PUSH");
	    $$ = 1;
	}
    | NUM
	{
	    comment("--- set ---");
	    instarg("SET", $1);
	    inst("PUSH");
	    $$ = 1;
	}
    | IDENT LPAR { arg_size = 0; } Arguments RPAR
 	{
	    arg_size = $4;
	    comment("--- function call ---");
	    symbole s;
	    if ( ! findSymbole(varfonc, $1, &s) )
		error("fonction introuvable : ",$1);
	    // les arguments ont t PUSH avec Arguments 
	    // => dispos  partir de -3,
	    //    -4 si la fonction retourne quelque chose
	    if ( s.size )
		instarg("ALLOC", 1); // valeur de retour 
	    instarg("CALL", s.address);
	    if ( s.size ) // Sauvegarde la valeur de retour
		inst("POP");
	    instarg("FREE", arg_size); // Free les arguments
	    if ( s.size ) // Restaure la valeur de retour
		inst("PUSH");
	    if ( s.size )
		$$ = 1;
	    else
		$$ = 0;
	}
   ;

FixLabel: 
	{
	    label($$ = jump_label++);
	}
    ;

FixJump:
	{
	    jump("JUMP", $$ = jump_label++);
	}
    ;

FixJumpF:
	{
	    inst("POP");
	    jump("JUMPF", $$ = jump_label++);
	}
    ;

%%

void beginProgram(void)
{
    initSymbole(&varfonc);
    initSymbole(&constante);
}

void endProgram(void)
{
    inst("HALT");
}

int main(int argc, char ** argv)
{
    char c, * outfile;
    int i;
    FILE * out = stdout;

    tmpout = fopen("yytmpfile", "w");
    if ( argc == 2 )
	yyin = fopen(argv[1], "r");
    else if ( argc == 1 )
	yyin = stdin;
    else if ( argc == 3 ) {

	yyin = fopen(argv[1], "r");
	if ( strcmp(argv[2],"-o") != 0 ) {
	    fprintf(stderr,"Usage : %s <src> [-o]\n", argv[0]); 
	    return 1;
	}

	if ( (outfile = strstr(argv[1],".tpc")) != NULL ) {
	    outfile[1] = 'v';
	    outfile[2] = 'm';
	    outfile[3] = 0;
	    out = fopen(argv[1], "w");
	} else {
	    fprintf(stderr,"Type de fichier inconnu\n");
	    return 1;
	}
    } else {  
	fprintf(stderr, "Usage : %s <src> [-o]\n", argv[0]);
	return 1;
    }

    beginProgram();
    yyparse();
    endProgram();

    fclose(tmpout);

    tmpout = fopen("yytmpfile", "r");

    while ( (c = fgetc(tmpout)) != EOF ) {
	if ( c == 'x' ) {
	    fscanf(tmpout, "%d", &i);
	    fprintf(out,"%d", labels[i]);
	} else
	    fprintf(out,"%c", c);
    }

    fflush(stdout);
    system("rm yytmpfile");

    if ( yyin != stdin )
	fclose(yyin);
    if ( out != stdout )
	fclose(out);

    return 0;
}
