#include "yyutils.h"

int labels[65536];
int jump_label = 0;
int line_counter = 0;
int pushpop = 0;
extern FILE * tmpout;

extern table constante;
extern table varfonc;
extern table locale;
extern table localconst;
extern symbole * currfonction;

void throw_push(void)
{
    if ( pushpop ) {
	pushpop = 0;
	fprintf(tmpout, "\t%d\t%s\n", line_counter++, "PUSH");
    }
}

void inst(char * s) {
    if ( pushpop ) {
	pushpop = 0;
	if ( strcmp(s, "POP") == 0)
	    return;
	else
	    fprintf(tmpout, "\t%d\t%s\n", line_counter++, "PUSH");
    }

    if ( strcmp(s, "PUSH") == 0 ) {
	pushpop = 1;
	return;
    }

    fprintf(tmpout, "\t%d\t%s\n", line_counter++, s);
}

void instarg(char * s, int n)
{
    throw_push();
    fprintf(tmpout, "\t%d\t%s\t%d\n", line_counter++, s, n);
    line_counter++;
}

void jump(char * s, int n)
{
    throw_push();
    fprintf(tmpout, "\t%d\t%s\tx%d\t#goto %d\n", line_counter++, s, n, n);
    line_counter++;
}

void label(int n)
{
    if ( pushpop ) {
	pushpop = 0;
	fprintf(tmpout, "\t%d\t%s\n", line_counter++, "PUSH");
    }

    fprintf(tmpout, "#label: %d\n",n);

    labels[n] = line_counter;
}

void comment(char * s)
{
    fprintf(tmpout, "#%s\n", s);
}

void apply_un_op(char * op)
{
    inst("POP");
    inst(op);
    inst("PUSH");
}

void apply_bin_op(char * op)
{
    inst("POP"); 
    inst("SWAP");
    inst("POP");
    inst(op);
    inst("PUSH");
}

int yyerror(char * s)
{
    fprintf(stderr, "%s\n", s);
    return 0;
}

void error(char * msg, char * arg)
{
    fprintf(stderr, msg);
    fprintf(stderr, arg);
    fputc('\n',stderr);
    fprintf(stderr,"Table des symboles :\n > variables globales & fonctions\n");
    afficheSymbole(varfonc);
    fprintf(stderr," > constantes globales\n");
    afficheSymbole(constante);
    if ( currfonction )
	fprintf(stderr,"Fonction en cours de compilation : %s\n",currfonction->name);
    else
	fprintf(stderr,"Fonction en cours de compilation : main\n");
    fprintf(stderr," > variables locale\n");
    afficheSymbole(locale);
    fprintf(stderr," > constantes locales\n");
    afficheSymbole(localconst);
    exit(EXIT_FAILURE);
}

